GuildAdFilter = {}

function GuildAdFilter:IsSpamMessage(eventType, ...)
	if eventType ~= EVENT_CHAT_MESSAGE_CHANNEL then 
		return false
	end
	
	local messageType, fromName, text = ...

	if string.find(text, "%:guild%:") then
		 self.filteredCount = self.filteredCount + 1
		return true
	end
end

function GuildAdFilter.OnChatEvent(control, ...)
	if GuildAdFilter:IsSpamMessage(...) then
		return
	end
	
	GuildAdFilter.OnChatEventOrg(control, ...)
end

function GuildAdFilter:Initialize()
	self.lastChats = {}
	self.filteredCount = 0
	
	self.OnChatEventOrg = CHAT_SYSTEM.OnChatEvent
	CHAT_SYSTEM.OnChatEvent = GuildAdFilter.OnChatEvent
	
	SLASH_COMMANDS["/filteredcount"] = function()
		local pattern = "<<1>> <<1[message/messages]>> filtered out."
		CHAT_SYSTEM:AddMessage(zo_strformat(pattern, self.filteredCount))
	end
end

local function GuildAdFilterAddonLoaded(eventType, addonName)
	if addonName ~= "GuildAdFilter" then return end
	
	GuildAdFilter:Initialize()
end

EVENT_MANAGER:RegisterForEvent("GuildAdFilterInitialize", EVENT_ADD_ON_LOADED, GuildAdFilterAddonLoaded)